@ECHO OFF
TITLE CertNXtractionPack by SocraticBliss and SimonMKWii (R)

ECHO: && ECHO PRE-REQUISITES:
ECHO -- Get your BIS Keys (via biskeydump)
ECHO -- Dump your SYSNAND (via hekate)
ECHO -- Decrypt your PRODINFO (BIS 0 Key) and Save to file - PRODINFO.bin to your working directory (via HacDiskMount)
ECHO -- keys.txt (ie. key = 32 digit hex value) file with the following keys...
ECHO --- master_key_00
ECHO --- rsa_private_kek_generation_source
ECHO --- ssl_rsa_kek_source_x
ECHO --- ssl_rsa_kek_source_y

ECHO:

REM Check the file dependencies
FOR %%G IN (CertNXtractionPack.py keys.txt openssl.exe PRODINFO.bin) DO (
IF NOT EXIST %%G (ECHO Error: Place %%G in this directory then run again! && SET ERRORLEVEL=1)
)
IF %ERRORLEVEL% NEQ 0 (ECHO: && PAUSE && EXIT /B)

REM Check if python is installed
ECHO ;%PATH%; | FIND /C /I "python" >NUL
IF %ERRORLEVEL% NEQ 0 (ECHO: && PAUSE && ECHO Error: Install Python to your path then run again! && EXIT /B)

REM Install dependencies (if needed)
ECHO Checking python module dependencies...
python.exe -m pip -q install -U pip setuptools pycryptodome enum34 future asn1
IF %ERRORLEVEL% NEQ 0 (ECHO: && PAUSE && EXIT /B)

REM Run Python Script
python.exe -W ignore::DeprecationWarning CertNXtractionPack.py
IF %ERRORLEVEL% NEQ 0 (ECHO: && PAUSE && EXIT /B)

REM Finish up!
openssl.exe x509 -inform DER -in certificate.der -outform PEM -out certificate.pem >NUL 2>&1
IF %ERRORLEVEL% NEQ 0 (ECHO: && PAUSE && EXIT /B)

openssl.exe rsa -inform DER -in privatekey.der -outform PEM -out privatekey.pem >NUL 2>&1
TYPE certificate.pem privatekey.pem > nx_tls_client_cert.pem 2>&1
openssl.exe pkcs12 -export -in nx_tls_client_cert.pem -out nx_tls_client_cert.pfx -passout pass:switch >NUL 2>&1
DEL certificate.der >NUL 2>&1
DEL privatekey.der >NUL 2>&1

ECHO:
ECHO Saved certificate.pem, privatekey.pem, nx_tls_client_cert.pem, and nx_tls_client_cert.pfx to your working directory.
ECHO pfx password = switch
ECHO:

PAUSE >NUL | SET/P=Press the any key to exit...